=== debian/changelog ===
ausweisapp2 (1.20.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:10:07 +0100

ausweisapp2 (1.20.0-1) unstable; urgency=medium

  * New upstream release
  * Add patch to disable vendor name
  * Add patch to fix desktop icon path
  * Drop 0001-Disable-auto-updater.patch, fixed upstream
  * Drop 0002-Disable-Qt-Quick.patch, fixed upstream
  * Drop 0003-Fix-path-for-application-icon.patch, fixed upstream
  * Drop 0004-Fix-path-for-configuration-file.patch, fixed upstream
  * Drop 0005-Fix-path-for-resource-file.patch, fixed upstream
  * Drop 0006-Fix-path-for-translation-files.patch, fixed upstream
  * Update debian/patches/series
  * Add libhttp-parser-dev to Build-Depends
  * Add qtdeclarative5-dev to Build-Depends
  * Add qtquickcontrols2-5-dev to Build-Depends
  * Add qml-module-qt-labs-platform to Depends for ausweisapp2 package
  * Improve wording and grammar in summary and description
  * Remove manual installation of shared data in debian/rules
  * Update installation path of desktop icon in debian/rules

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 18 Jan 2020 15:59:04 +0100
